# Documentation

Guava helps you to extend your unit tests with `TestDouble` entities, such as `Stub`, `Spy` and `Fake`. It allows you to replace parts of your system under test with test double objects.

These guides will help you to use the Guava to test your code more efficiently:

> All examples are availble in `ExampleTests` directory of Guava's `Tests` module.

- [Setting up test case dependencies with TestDoubleFactory](TestDoubleFactory.md)
- [Stubbing return value](StubbingReturnValue.md)
- [Spying on function](SpyingOnFuncation.md)
- [Faking method functionality](FakingMethodFunctionality.md)
- [Handling assertion results](HandlingFailures.md)